#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <vip_core>

public Plugin:myinfo =
{
	name = "[VIP] Top Icon",
	author = "R1KO",
	version = "1.1"
};

static const String:g_sFeature[] = "TopIcon";

new g_iIcon[MAXPLAYERS+1] = {-1, ...};

new bool:g_Cvar_bHide;

public OnPluginStart() 
{
	new Handle:hCvar = CreateConVar("vip_top_icon_hide_opposite_team", "1", "Скрывать ли модели для противников (0 - Нет, 1 - Да)", _, true, 0.0, true, 1.0);
	HookConVarChange(hCvar, OnHideChange);
	g_Cvar_bHide = GetConVarBool(hCvar);

	AutoExecConfig(true, "VIP_TopIcon", "vip");

	HookEvent("player_death",	Event_KillIcon);
	HookEvent("player_team",	Event_KillIcon);

	if(VIP_IsVIPLoaded())
	{
		VIP_OnVIPLoaded();
	}
}

public OnHideChange(Handle:hCvar, const String:sOldValue[], const String:sNewValue[])	g_Cvar_bHide = GetConVarBool(hCvar);

public OnPluginEnd() 
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
	{
		VIP_UnregisterFeature(g_sFeature);
	}
}

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, STRING, _, OnToggleItem);
}

public Action:OnToggleItem(iClient, const String:sFeatureName[], VIP_ToggleState:OldStatus, &VIP_ToggleState:NewStatus)
{
	if(NewStatus == ENABLED)
	{
		CreateIcon(iClient);
	}
	else
	{
		RemoveIcon(iClient);
	}

	return Plugin_Continue;
}

public Event_KillIcon(Handle:hEvent, const String:sEvName[], bool:bDontBroadcast)
{	
	RemoveIcon(GetClientOfUserId(GetEventInt(hEvent, "userid")));
}

public VIP_OnPlayerSpawn(iClient, iTeam, bool:bIsVIP)
{
	if(bIsVIP && VIP_IsClientFeatureUse(iClient, g_sFeature))
	{
		CreateIcon(iClient);
	}
}

public VIP_OnVIPClientLoaded(iClient)
{
	if(VIP_GetClientFeatureStatus(iClient, g_sFeature) != NO_ACCESS)
	{
		decl String:sModel[PLATFORM_MAX_PATH];
		VIP_GetClientFeatureString(iClient, g_sFeature, sModel, sizeof(sModel));
		PrecacheModel(sModel);
	}
}

RemoveIcon(iClient)
{
	if (g_iIcon[iClient] != -1 && IsValidEntity(g_iIcon[iClient]))
	{
		AcceptEntityInput(g_iIcon[iClient], "Kill");
	}

	g_iIcon[iClient] = -1;
}

public OnClientDisconnect(iClient)
{
	g_iIcon[iClient] = -1;
}

public OnClientPutInServer(iClient)
{
	g_iIcon[iClient] = -1;
}

CreateIcon(iClient)
{
	RemoveIcon(iClient);

	g_iIcon[iClient] = CreateEntityByName("prop_dynamic");
	if(g_iIcon[iClient] != -1)
	{
		decl String:sModel[PLATFORM_MAX_PATH];
		VIP_GetClientFeatureString(iClient, g_sFeature, sModel, sizeof(sModel));
		DispatchKeyValue(g_iIcon[iClient], "DefaultAnim", "rotate");
		DispatchKeyValue(g_iIcon[iClient], "spawnflags", "256");
		DispatchKeyValue(g_iIcon[iClient], "model", sModel);
		DispatchKeyValue(g_iIcon[iClient], "solid", "6");
		
		if (DispatchSpawn(g_iIcon[iClient]))
		{
			decl Float:fPos[3];
			GetClientAbsOrigin(iClient, fPos);
			fPos[2] += 90.0;
			TeleportEntity(g_iIcon[iClient], fPos, NULL_VECTOR, NULL_VECTOR);

			SetVariantString("!activator");
			AcceptEntityInput(g_iIcon[iClient], "SetParent", iClient);

			SetEntPropEnt(g_iIcon[iClient], Prop_Send, "m_hOwnerEntity", iClient);
			
			if(g_Cvar_bHide)
			{
				SDKHook(g_iIcon[iClient], SDKHook_SetTransmit, OnTransmit);
			}
		}
	}
}

public Action:OnTransmit(iEntity, iClient)
{
	if (g_iIcon[iClient] == iEntity)
	{
		return Plugin_Continue;
	}
	
	static iOwner, iTeam;
	iTeam = GetClientTeam(iClient);

	if (iTeam < 2)
	{
		return Plugin_Continue;
	}

	if ((iOwner = GetEntPropEnt(iEntity, Prop_Send, "m_hOwnerEntity")) > 0 && GetClientTeam(iOwner) != iTeam)
	{
		return Plugin_Handled;
	}

	return Plugin_Continue;
}